/*
Written by Craig Stanton 
You may not copy or duplicate the code unless you ask me nicely first. 



http://craig.stanton.net.nz
*/

var loggedIn = false;
var BoldOn = false;
var ItalicOn = false;
var UnderlineOn = false;
var LJCutOn = false;
var LinkOn = false;
var MAX_DROPLIST_LENGTH = 9;
var MAX_ERROR_LENGTH = 130;
var usernameKey = 'LiveJournalUsername';
var passwordKey = 'LiveJournalPassword';
var colourKey = 'LiveWidgetColourScheme';
var NEW_LINE = '\r\n';
var NEW_LINE_HTML = '<br>';
var colourScheme;
var DEFAULT_COLOUR_SCHEME = 'blue';



function setup(){
		restoreColourPrefs();
		restoreUserLogin();
		var doneButton = document.getElementById('done_button');
		createGenericButton (doneButton, 'Done', hidePrefs);
		clearPrivacy();
		setupPrivacy();
		clearJournals();
		setupJournals();
}

 function openURL(url) {
        if (window.widget) {
            widget.openURL(url);
        }
        else {
            window.location.href = url;
        }
    }

function growWidget(){
	var front = document.getElementById("front");
	var mini = document.getElementById("mini");
	mini.style.display="none";		
	front.style.display="block";		
}
function shrinkWidget(){
	var front = document.getElementById("front");
	var mini = document.getElementById("mini");
	front.style.display="none";		
	mini.style.display="block";		
}

function changeSheets (styleName) {		
	styleSheetName = styleName + '-style.css';
	document.getElementById('themeStyleSheet').href= styleSheetName;

	moodImg = document.getElementById("mood_img");
	moodImg.src = "Images/"+styleName+"/circle_drop.png";

	friendGroupsImg = document.getElementById("friends_groups_img");
	friendGroupsImg.src = "Images/"+styleName+"/droplist.png";

	journalsImg = document.getElementById("journals_img");
	journalsImg.src = "Images/"+styleName+"/droplist.png";

	userpicsImg = document.getElementById("userpics_img");
	userpicsImg.src = "Images/"+styleName+"/droplist.png";

	colourScheme = styleName;
	saveColourPrefs();

}

function saveUserLogin(){
	backForm = document.backForm;
	if (window.widget){
		widget.setPreferenceForKey(backForm.username.value, usernameKey);
		//disabled until it is safe
		//widget.setPreferenceForKey(backForm.password.value, passwordKey);
		
		if (PasswordPlugin){
			PasswordPlugin.makePassword(backForm.username.value, backForm.password.value, "LiveWidgetPassword");
		}
		
	}
}

function saveColourPrefs(){
	if (window.widget){
		widget.setPreferenceForKey(colourScheme, colourKey);
	}
}

function restoreColourPrefs(){
	
	if (window.widget){
		colourScheme = widget.preferenceForKey(colourKey);
		//document.mainForm.entry.value = 'colour---' + colourScheme + '---';
		if (colourScheme == undefined) {
			colourScheme = DEFAULT_COLOUR_SCHEME;
		}
		changeSheets(colourScheme);
	}
}

function restoreUserLogin(){
	backForm = document.backForm;
	theForm = document.mainForm;
	if (window.widget){
		var savedUsername = widget.preferenceForKey(usernameKey);
		if (savedUsername != undefined) {
			backForm.username.value = savedUsername;
			theForm.journals.options.length = 0;
			addOptionToList(theForm.journals, backForm.username.value, '');
			theForm.journals.options.selectedIndex = 0;
			changeList("journals_list", "journals_text");
		}
		if (PasswordPlugin){
			backForm.password.value = PasswordPlugin.getPassword(backForm.username.value, "LiveWidgetPassword");
		}
		
		if ((backForm.password.value.length > 0) & (backForm.password.value.length > 0)){
			startGetInfo();
		}
	}
}


function changeMood(){
	theForm = document.mainForm;
	moodList = document.getElementById("mood_list");
	theForm.mood_text.value = moodList.options[moodList.selectedIndex].name;
}

function changeList(aList, aText){
	theText = document.getElementById(aText);
	theList = document.getElementById(aList);
	
	newText = theList.options[theList.selectedIndex].text+'';
	if (newText.length > MAX_DROPLIST_LENGTH){
		newText = newText.substring(0, MAX_DROPLIST_LENGTH-1) + '...';
	}

	theText.innerHTML = newText;
}

function insertBold()
{
	theEntry = document.mainForm.entry.value;
	if (BoldOn)
	{
		theEntry = theEntry + '</b>';
		BoldOn = false;
	}	
	else
	{
		theEntry = theEntry + '<b>';
		BoldOn = true;
	}
	document.mainForm.entry.value = theEntry;
	document.mainForm.entry.focus();
}

function insertItalic()
{
	theEntry = document.mainForm.entry.value;
	if (ItalicOn)
	{
		theEntry = theEntry + '</i>';
		ItalicOn = false;
	}	
	else
	{
		theEntry = theEntry + '<i>';
		ItalicOn = true;
	}
	document.mainForm.entry.value = theEntry;
	document.mainForm.entry.focus();

}
function insertUnderline()
{
	theEntry = document.mainForm.entry.value;
	if (UnderlineOn)
	{
		theEntry = theEntry + '</u>';
		UnderlineOn = false;
	}	
	else
	{
		theEntry = theEntry + '<u>';
		UnderlineOn = true;
	}
	document.mainForm.entry.value = theEntry;
	document.mainForm.entry.focus();
}


function insertImage()
{
	theEntry = document.mainForm.entry.value;
	theEntry = theEntry + '<img src="" width="" height="" alt="">';
	document.mainForm.entry.value = theEntry;
	document.mainForm.entry.focus();
}

function insertLink()
{
	theEntry = document.mainForm.entry.value;
	if (LinkOn)
	{
		theEntry = theEntry + '</a>';
		LinkOn = false;
	}	
	else
	{
		theEntry = theEntry + '<a href="">';
		LinkOn = true;
	}
	document.mainForm.entry.value = theEntry;
	document.mainForm.entry.focus();
}

function insertLJCut()
{
	theEntry = document.mainForm.entry.value;
	if (LJCutOn)
	{
		theEntry = theEntry + '</lj-cut>';
		LJCutOn = false;
	}	
	else
	{
		theEntry = theEntry + '<lj-cut>';
		LJCutOn = true;
	}
	document.mainForm.entry.value = theEntry;
	document.mainForm.entry.focus();
}


function createPass(){
	theForm = document.mainForm;
	theForm.music.value = md5me(theForm.subject.value, theForm.music.value);
}

function boldThis()
{ 
	strSelection = document.selection.createRange().text ;
	if (strSelection == "") { 
		return false; 
	} 
	else 
		//document.getSelection().text = "<b>" + strSelection + "</b>" 
		document.entry.value = document.getSelection();
	return;
}

function md5me(theChallenge, thePassword)
{
	return hex_md5(theChallenge + hex_md5(thePassword));
}

function getMusic()
{
	theForm = document.mainForm;
	musicHandler(widget.system("/usr/bin/osascript getMusic.scpt" ,null).outputString);
}

function musicHandler(theMusic)
{
	theForm = document.mainForm;
	theForm.music.value = theMusic;
}

function putValueInEntry()
{
	groupList = document.mainForm.friendsgroups;
	document.mainForm.entry.value = groupList.options[groupList.selectedIndex].value;
}

function clearPrivacy(){
	theForm.friendsgroups.options.length = 0;
}

function setupPrivacy(){
	addOptionToList(theForm.friendsgroups, 'Public', 'public');
	addOptionToList(theForm.friendsgroups, 'Private', 'private');
	addOptionToList(theForm.friendsgroups, 'Friends Only', 0);
	theForm.friendsgroups.options.selectedIndex = 0;
	changeList("friends_groups_list", "friends_groups_text");
}

function populatePrivacy(groupsXML){
	theForm = document.mainForm;
	groupList = theForm.friendsgroups;
	entryField = theForm.entry;

	var parser = new DOMImplementation();
	var domDoc = parser.loadXML(groupsXML);

	var friendStructsList = domDoc.getFirstChild().getFirstChild().getElementsByTagName("struct");

	for( fs_counter = 0; fs_counter < friendStructsList.length; fs_counter ++) {
		var aStruct = friendStructsList.item(fs_counter);
		var memberList = aStruct.getElementsByTagName("member");
		aGroupName = memberList.item(1).getLastChild().getFirstChild().getFirstChild();
		aGroupID = memberList.item(2).getLastChild().getFirstChild().getFirstChild();
		addOptionToList(groupList, aGroupName, aGroupID);
	}	
}


function clearJournals(){
	theForm.journals.options.length = 0;
}

function setupJournals(){
	addOptionToList(theForm.journals, backForm.username.value, backForm.username.value);
	theForm.journals.options.selectedIndex = 0;
	changeList("journals_list", "journals_text");
}

function populateJournals(journalsXML){
	theForm = document.mainForm;
	journalList = theForm.journals;
	//entryField = theForm.entry;
	var journalParser = new DOMImplementation();
	var journalDoc = journalParser.loadXML(journalsXML);
	var journalNameList = journalDoc.getElementsByTagName("string");

	for( jn_counter = 0; jn_counter < journalNameList.length; jn_counter++) {
		var aJournalName = journalNameList.item(jn_counter).getFirstChild();
		addOptionToList(journalList, aJournalName, aJournalName);
	}	
}

function clearUserpics(){
	theForm.userpics.options.length = 0;
}

function setupUserpics(){
	addOptionToList(theForm.userpics, "default", "");
	theForm.userpics.options.selectedIndex = 0;
	changeList("userpics_list", "userpics_text");
}
function populateUserpics(userpicsXML){
	//alert('THE USER PIC XML IS '+userpicsXML);
	theForm = document.mainForm;
	userpicList = theForm.userpics;
	//entryField = theForm.entry;
	var userpicParser = new DOMImplementation();
	var userpicDoc = userpicParser.loadXML(userpicsXML);
	var userpicNameList = userpicDoc.getElementsByTagName("string");

	for( up_counter = 0; up_counter < userpicNameList.length; up_counter++) {
		var aUserpic = userpicNameList.item(up_counter).getFirstChild();
		addOptionToList(userpicList, aUserpic, aUserpic);
	}	
}

function addOptionToList(theList, theOption, theValue){
	theList.options[theList.options.length] = new Option(theOption, theValue);
}

function startGetInfo(){
	setBackStatus("<img valign=middle src=Images/spinner.gif> getting user info from LiveJournal", "getInfoFromServer()");

//	strResult = calcPost();
//	theForm.entry.value = strResult;
}

function getInfoFromServer(){
	var journalListXML = '';

	theForm=document.mainForm;
	backForm=document.backForm;
	backStatusDiv = document.getElementById('status_label_back');

	clearPrivacy();
	setupPrivacy();

	clearJournals();
	setupJournals();
	
	clearUserpics();
	setupUserpics();
	
	var xmlhttp, strResult;
  	xmlhttp = new XMLHttpRequest;
	xmlhttp.open("POST", "http://www.livejournal.com/interface/xmlrpc",false);
 	xmlhttp.onreadystatechange=function() {
  		if (xmlhttp.readyState==4) {
  			alert(xmlhttp.responseText)
  		}
 	}
 	xmlhttp.setRequestHeader("Man", "POST /interface/xmlrpc HTTP/1.0")
 	xmlhttp.setRequestHeader("MessageType", "CALL")
 	xmlhttp.setRequestHeader("Content-Type", "text/xml")
	
	strResult = '<?xml version="1.0"?>'+
		'<methodCall>'+
		'<methodName>LJ.XMLRPC.login</methodName>'+
		'<params>'+		
		'<param>'+	
		'<value><struct>'+	
		getLoginInfo()+
		'<member><name>getpickws</name>'+
		'<value><int>1</int></value>'+
		'</member>'+
		'</struct></value>'+
		'</param>'+
		'</params>'+
		'</methodCall>';

 	xmlhttp.send(strResult);
	//alert('String after gettting login ' + strResult);

	strResult= xmlhttp.responseText;

	var parser = new DOMImplementation();
	//load the XML into the parser and get the DOMDocument
	var domDoc = parser.loadXML(strResult);
	var docRoot = domDoc.getDocumentElement();

	faultString = extractFaultString(docRoot);

	if(faultString != ''){ 
		backStatusDiv.innerHTML = '<img valign=middle src=Images/Error.png> '+faultString;
	}
	else
	{
		
		messsageString = extractMessage(docRoot);
	
		if(messsageString != ''){ 
			backStatusDiv.innerHTML = '<img valign=middle src=Images/Info.png> '+messsageString;
		}
		else
		{	
		
		
			backStatusDiv.innerHTML = '<img valign=middle src=Images/OK.png> No faults reported';
			memberList = docRoot.getElementsByTagName("member");
			for(i = 0; i < memberList.length; i++){
				aMemberItem = memberList.item(i).getFirstChild().getFirstChild();
				if (aMemberItem == 'friendgroups') {				
					friendGroupXML = memberList.item(i).getLastChild().getFirstChild();
					populatePrivacy(friendGroupXML+'');		
					numOfFriendsGroups = theForm.friendsgroups.length;
					backStatusDiv.innerHTML +=	NEW_LINE_HTML + numOfFriendsGroups + ' groups available';
				}
				if (aMemberItem == 'usejournals') {
					journalListXML = memberList.item(i).getLastChild().getFirstChild() + '';
					populateJournals(journalListXML +'');				
					numOfJournals = theForm.journals.options.length;
					backStatusDiv.innerHTML +=	NEW_LINE_HTML + numOfJournals + ' journals available';
				}
				if (aMemberItem == 'pickws') {
					userpicsListXML = memberList.item(i).getLastChild().getFirstChild() + '';
					populateUserpics(userpicsListXML +'');				
					numOfUserpics = theForm.userpics.options.length;
					backStatusDiv.innerHTML +=	NEW_LINE_HTML + numOfUserpics + ' user pics available';
				}
			}
		}
	}
}

function extractFaultString(theDocRoot){
	theResult = '';
	var faultList = theDocRoot.getElementsByTagName("fault");

	if (faultList.getLength() > 0) {
		theResult = theDocRoot.getFirstChild().getFirstChild().getFirstChild().getFirstChild().getLastChild().getFirstChild().getFirstChild();
	}
	return theResult;
}


function extractMessage(theDocRoot){
	theResult = '';
	var messageList = theDocRoot.getElementsByTagName("member");

	if (messageList.getLength() == 1) {
		theResult = theDocRoot.getFirstChild().getFirstChild().getFirstChild().getFirstChild().getFirstChild().getLastChild().getFirstChild().getFirstChild();
	}
	return theResult;
}
function extractLoginMessage(theDocRoot){//NOT USED
	theResult = '';
	var messageList = theDocRoot.getElementsByTagName("message");




	if (messageList.getLength() == 1) {
		var memberList = theDocRoot.getElementsByTagName("member");
		var memberDoc = parser.loadXML(memberList);
		var memberRoot = memberDoc.getDocumentElement();
		theResult = memberRoot.getLastChild();
	}
	return theResult;
}

function extractSuccessURL(theDocRoot){
	theResult = '';
	var memberList = theDocRoot.getElementsByTagName("member");
	
	for ( i = 0; i<memberList.length; i++){
		aMemberItem = memberList.item(i).getFirstChild().getFirstChild();
		if (aMemberItem == 'url') {				
				successURL = memberList.item(i).getLastChild().getFirstChild().getFirstChild() + '';
			//	if (successURL.substring(0, 4) == 'http'){
					theResult = successURL;
			//	}
			}
	}

	return theResult;
}

function setFrontStatus(imgCode, status, callback){
	statusDiv = document.getElementById('status_label_front');
	statusImg = document.getElementById('status_img_front');
	statusDiv.innerHTML = status;
	statusImg.innerHTML = imgCode;
	setTimeout(callback, 175);
}
function setBackStatus(status, callback){
	statusDiv = document.getElementById('status_label_back');
	statusDiv.innerHTML = status;
	setTimeout(callback, 175);
}

function startPostEntry(){
	setFrontStatus("<img valign=middle src=Images/spinner.gif>","submitting to LiveJournal", "postEntry()");

//	strResult = calcPost();
//	theForm.entry.value = strResult;
}

function postEntry()
{	
	theForm=document.mainForm;
	frontStatusDiv = document.getElementById('status_label_front');
	frontStatusImg = document.getElementById('status_img_front');
	var xmlhttp, strResult;
  	xmlhttp = new XMLHttpRequest;
	xmlhttp.open("POST", "http://www.livejournal.com/interface/xmlrpc",false);
 	xmlhttp.onreadystatechange=function() {
  		if (xmlhttp.readyState==4) {
  			alert(xmlhttp.responseText)
  		}
 	}
 	xmlhttp.setRequestHeader("Man", "POST /interface/xmlrpc HTTP/1.0")
 	xmlhttp.setRequestHeader("MessageType", "CALL")
 	xmlhttp.setRequestHeader("Content-Type", "text/xml")

	thePost=calcPost();
//theForm.entry.value = thePost;
 	xmlhttp.send(thePost);

	strResult= xmlhttp.responseText;
	
	var parser = new DOMImplementation();
	//load the XML into the parser and get the DOMDocument
	var domDoc = parser.loadXML(strResult);
	var docRoot = domDoc.getDocumentElement();

	faultString = extractFaultString(docRoot) + '';

	if(faultString != ''){ 
		if (faultString.length > MAX_ERROR_LENGTH){
			faultString = faultString.substring(0, MAX_ERROR_LENGTH-1) + '...';
		}
		frontStatusDiv.innerHTML = faultString;
		frontStatusImg.innerHTML = '<img valign=middle src=Images/Error.png>';

		//theForm.reset();
	}else{
		
		messsageString = extractMessage(docRoot);
	
		if(messsageString != ''){ 
			frontStatusDiv.innerHTML = messsageString;
			frontStatusImg.innerHTML = '<img valign=middle src=Images/Info.png>';
		}
		else{	
		
			postURL = extractSuccessURL(docRoot) + '';	
			
			var selectedPrivacy = theForm.friends_groups_list.selectedIndex;
			theForm.reset();
			theForm.friends_groups_list.selectedIndex = selectedPrivacy;
			
			frontStatusDiv.innerHTML = '<u><a onClick="openURL(\''+ postURL+'\');">View your post</a></u>';
			frontStatusImg.innerHTML = '<img valign=middle src=Images/OK.png>';
	

			//strResult = calcPost();
			//
	
		}
	}
}

function calcPost()
{	
	theForm=document.mainForm;
	loginForm=document.backForm;
	username= loginForm.username.value;
	password= loginForm.password.value;
	subject=theForm.subject.value;
	entry=theForm.entry.value;

//	newChallenge = parseIt(getChallenge());
//	newResponse = md5me(newChallenge, password);
	
	
	var dd=new Date;
	day=dd.getDate();
	month=dd.getMonth()+1;
	year=dd.getFullYear();
	hour=dd.getHours();
	min=dd.getMinutes();



	var xmlhttp, strResult;
  	xmlhttp = new XMLHttpRequest;
	xmlhttp.open("POST", "http://www.livejournal.com/interface/xmlrpc",false);
 	xmlhttp.onreadystatechange=function() {
  		if (xmlhttp.readyState==4) {
  			alert(xmlhttp.responseText)
  		}
 	}
 	xmlhttp.setRequestHeader("Man", "POST /interface/xmlrpc HTTP/1.0")
 	xmlhttp.setRequestHeader("MessageType", "CALL")
 	xmlhttp.setRequestHeader("Content-Type", "text/xml")

	strResult=
		'<?xml version="1.0"?>'+
		'<methodCall>'+
		'<methodName>LJ.XMLRPC.postevent</methodName>'+
		'<params>'+
		'<param>'+
		''+
		'<value><struct>'+
		
		getLoginInfo()+
		'<member><name>event</name>'+
		'<value><string><![CDATA['+entry+']]></string></value>'+
		'</member>'+
		
		'<member><name>lineendings</name>'+
		'<value><string>mac</string></value>'+
		'</member>'+
	
		'<member><name>subject</name>'+
		'<value><string><![CDATA['+subject+']]></string></value>'+
		'</member>'+

		getSecurity()+

		'<member><name>ver</name>'+
		'<value><string>1</string></value>'+
		'</member>'+

		'<member><name>year</name>'+
		'<value><string>'+year+'</string></value>'+
		'</member>'+

		'<member><name>mon</name>'+
		'<value><string>'+month+'</string></value>'+
		'</member>'+

		'<member><name>day</name>'+
		'<value><string>'+day+'</string></value>'+
		'</member>'+

		'<member><name>hour</name>'+
		'<value><string>'+hour+'</string></value>'+
		'</member>'+

		'<member><name>min</name>'+
		'<value><string>'+min+'</string></value>'+
		'</member>'+

		getProps()+


		getJournal()+

		'</struct></value>'+
		''+
		'</param>'+
		'</params>'+
		'</methodCall>';
//	strResult= xmlhttp.responseText;
//	theForm.event.value=strResult;
	return strResult;
}

function sendContents(){
	var xmlhttp, strResult;
	var theForm=document.form1;

	
  	xmlhttp = new XMLHttpRequest;
	xmlhttp.open("POST", "http://www.livejournal.com/interface/xmlrpc",false);
 	xmlhttp.onreadystatechange=function() {
  		if (xmlhttp.readyState==4) {
  			alert(xmlhttp.responseText)
  		}
 	}
 	xmlhttp.setRequestHeader("Man", "POST /interface/xmlrpc HTTP/1.0")
 	xmlhttp.setRequestHeader("MessageType", "CALL")
 	xmlhttp.setRequestHeader("Content-Type", "text/xml")

	xmlhttp.send(theForm.event.value);

	strResult= xmlhttp.responseText;
	
	theForm.event.value=strResult;
}

function getJournal(){
	theForm = document.mainForm;
	theJournal= theForm.journals.value;
	
	return '<member><name>usejournal</name>' +
			'<value><string>' + theJournal + '</string></value>' +
			'</member>';

}

function getProps(){
	theForm=document.mainForm;

	music= theForm.music.value;
	mood=theForm.mood_text.value;
	userpic = theForm.userpics.value;
	tags = theForm.tags.value;
	moodString = '';
	musicString = '';
	userpicString = '';
	tagString = '';

	if (mood != ''){
			for( mCounter = 0; mCounter < theForm.mood_list.length; mCounter ++){
				if (theForm.mood_list.options[mCounter].name == mood){
					moodId = theForm.mood_list.options[theForm.mood_list.options.selectedIndex].value;
					moodString = '<member>'+
                    				'<name>current_moodid</name>'+
                    				'<value>'+moodId+'</value>'+
			                	'</member>';
				}
			}
		}

	if (moodString == ''){
		moodString = '<member>'+
                    	'<name>current_mood</name>'+
                    	'<value><![CDATA['+ (mood) +']]></value>'+
                	'</member>';
	}

    if (music != ''){
        musicString = '<member>'+
                    '<name>current_music</name>'+
                    '<value><base64>' + encode64(music)+'</base64></value>'+
                '</member>';
    }
	if (userpic != ''){
        userpicString = '<member>'+
                    '<name>picture_keyword</name>'+
                    '<value>' + userpic + '</value>'+
                '</member>';
    }

	if (tags != ''){
        tagString = '<member>'+
                    '<name>taglist</name>'+
                    '<value>' + tags + '</value>'+
                '</member>';
    }



	thePropsResult =	'<member>'+
        '<name>props</name>'+
        '<value>'+
            '<struct>'+
            	musicString+
				moodString+
				userpicString+
				tagString+
            '</struct>'+
        '</value>'+
    	'</member>';

	//alert(thePropsResult);
	return thePropsResult;
}


function getAllowMask(idNum){
	anInt = 1;
	for (i = 0; i< idNum; i++){
		anInt = anInt << 1;
	}
	return anInt;
}


function getSecurity(){
	theForm = document.mainForm;
	privacyLevel= theForm.friendsgroups.value;
	theSecurityResult = '';


	if (isNaN(privacyLevel)){
		theSecurityResult = '<member><name>security</name>'+
			'<value><string>'+ privacyLevel +'</string></value>'+
			'</member>';
	}else{

		theSecurityResult = '<member><name>security</name>'+
			'<value><string>usemask</string></value>'+
			'</member>';
		theSecurityResult += '<member><name>allowmask</name>'+
			'<value><int>'+getAllowMask(parseInt(privacyLevel))+'</int></value>'+
			'</member>';
	}
	return theSecurityResult;
}

function getLoginInfo(){

	var theForm=document.backForm;
	theUsername = theForm.username.value;
	thePassword = theForm.password.value;
	
	newChallenge = parseIt(getChallenge());
	newResponse = md5me(newChallenge, thePassword);

	return '<member><name>username</name>'+
		'<value><string>'+theUsername+'</string></value>'+
		'</member>'+
		'<member><name>auth_method</name>'+
		'<value><string>challenge</string></value>'+
		'</member>'+
		'<member><name>auth_challenge</name>'+
		'<value><string>'+ newChallenge +'</string></value>'+
		'</member>'+
		'<member><name>auth_response</name>'+
		'<value><string>'+ newResponse +'</string></value>'+
		'</member>';
	
}

function getChallenge(){
	var xmlhttp, strResult;
	var theForm=document.mainForm;
  	xmlhttp = new XMLHttpRequest;
	xmlhttp.open("POST", "http://www.livejournal.com/interface/xmlrpc",false);
 	xmlhttp.onreadystatechange=function() {
  		if (xmlhttp.readyState==4) {
  			alert(xmlhttp.responseText)
  		}
 	}
 	xmlhttp.setRequestHeader("Man", "POST /interface/xmlrpc HTTP/1.0")
 	xmlhttp.setRequestHeader("MessageType", "CALL")
 	xmlhttp.setRequestHeader("Content-Type", "text/xml")

	xmlhttp.send('<?xml version="1.0"?>'+
		'<methodCall>'+
		'<methodName>LJ.XMLRPC.getchallenge</methodName>'+
		'<params>'+
		'</params>'+
		'</methodCall>');
	strResult= xmlhttp.responseText;
	
	//theForm.event.value=strResult;
	//theForm.subject.value = ParseIt(strResult);
	return strResult;
}


function parseIt(challengeXML)
{
	//instantiate the W3C DOM Parser
	var parser = new DOMImplementation();
	var theForm=document.mainForm;

	//load the XML into the parser and get the DOMDocument
	var domDoc = parser.loadXML(challengeXML);

	//get the root node
	var docRoot = domDoc.getDocumentElement();

	var membersNodeList = domDoc.getElementsByTagName("member");

	//get a DOMNamedNodeMap of the attributes for tag1
	//alert("LOOK AT ME" + membersNodeList);
	var theChallenge = membersNodeList.item(2).getLastChild().getFirstChild().getFirstChild().getNodeValue();
	return theChallenge;
}




/****************Start Apple Code*****************/

// showPrefs() is called when the preferences flipper is clicked upon.  It freezes the front of the widget,
// hides the front div, unhides the back div, and then flips the widget over.

function showPrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToBack");		// freezes the widget so that you can change it without the user noticing
	
	front.style.display="none";		// hide the front
	back.style.display="block";		// show the back
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget over	

	document.getElementById('fliprollie').style.display = 'none';  // clean up the front side - hide the circle behind the info button

}


// hidePrefs() is called by the done button on the back side of the widget.  It performs the opposite transition
// as showPrefs() does.

function hidePrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToFront");		// freezes the widget and prepares it for the flip back to the front
	
	back.style.display="none";			// hide the back
	front.style.display="block";		// show the front
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget back to the front

}

// PREFERENCE BUTTON ANIMATION (- the pref flipper fade in/out)

var flipShown = false;		// a flag used to signify if the flipper is currently shown or not.


// A structure that holds information that is needed for the animation to run.
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};


// mousemove() is the event handle assigned to the onmousemove property on the front div of the widget. 
// It is triggered whenever a mouse is moved within the bounds of your widget.  It prepares the
// preference flipper fade and then calls animate() to performs the animation.

function mousemove (event)
{
	if (!flipShown)			// if the preferences flipper is not already showing...
	{
		if (animation.timer != null)			// reset the animation timer value, in case a value was left behind
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; 		// set it back one frame
		
		animation.duration = 500;												// animation time, in ms
		animation.starttime = starttime;										// specify the start time
		animation.firstElement = document.getElementById ('flip');		// specify the element to fade
		animation.timer = setInterval ("animate();", 13);						// set the animation function
		animation.from = animation.now;											// beginning opacity (not ness. 0)
		animation.to = 1.0;														// final opacity
		animate();																// begin animation
		flipShown = true;														// mark the flipper as animated
	}
}

// mouseexit() is the opposite of mousemove() in that it preps the preferences flipper
// to disappear.  It adds the appropriate values to the animation data structure and sets the animation in motion.

function mouseexit (event)
{
	if (flipShown)
	{
		// fade in the flip widget
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13;
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}


// animate() performs the fade animation for the preferences flipper. It uses the opacity CSS property to simulate a fade.

function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.firstElement.style.opacity = animation.now;
}


// these functions are utilities used by animate()

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

// these functions are called when the info button itself receives onmouseover and onmouseout events

function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}


/**************end Apple Code********************/

/****************** begin code from http://rumkin.com/tools/compression/base64.php ****************/

var keyStr = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";

function encode64(input) {
   var output = "";
   var chr1, chr2, chr3;
   var enc1, enc2, enc3, enc4;
   var i = 0;

   do {
      chr1 = input.charCodeAt(i++);
      chr2 = input.charCodeAt(i++);
      chr3 = input.charCodeAt(i++);

      enc1 = chr1 >> 2;
      enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
      enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
      enc4 = chr3 & 63;

      if (isNaN(chr2)) {
         enc3 = enc4 = 64;
      } else if (isNaN(chr3)) {
         enc4 = 64;
      }

      output = output + keyStr.charAt(enc1) + keyStr.charAt(enc2) + 
         keyStr.charAt(enc3) + keyStr.charAt(enc4);
   } while (i < input.length);
   
   return output;
}
/********* end borrowed code************/